<#assign import_block>
import { toastController, alertController } from '@ionic/core';
</#assign>
<#assign self_content>
    /**
     * 工作流审批意见控件绑定值
     *
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public srfwfmemo: string = "";

    /**
     * 工具栏模型数据
     *
     * @type {Array<any>}
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public linkModel: Array<any> = [];

    /**
     * 激活表单
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public activeForm:any = {};

    /**
     * 所有表单数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public allForm: any = {
    <#if view.getAllPSControls?? && view.getAllPSControls()??>
    <#list view.getAllPSControls() as singleControl>
    <#if singleControl.getControlType?? && singleControl.getControlType()?? && singleControl.getControlType() != "TOOLBAR">
        "${singleControl.getName()}":{name:"view_${singleControl.getName()}",autosave:"${singleControl.isEnableAutoSave()?c}",showBusyIndicator:"${singleControl.isShowBusyIndicator()?c}",updateAction:"<#if singleControl.getUpdatePSControlAction()?? && singleControl.getUpdatePSControlAction().getPSAppDEMethod()??>${singleControl.getUpdatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",removeAction:"<#if singleControl.getRemovePSControlAction()?? && singleControl.getRemovePSControlAction().getPSAppDEMethod()??>${singleControl.getRemovePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",loaddraftAction:"<#if singleControl.getGetDraftPSControlAction()?? && singleControl.getGetDraftPSControlAction().getPSAppDEMethod()??>${singleControl.getGetDraftPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",loadAction:"<#if singleControl.getGetPSControlAction()?? && singleControl.getGetPSControlAction().getPSAppDEMethod()??>${singleControl.getGetPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",createAction:"<#if singleControl.getCreatePSControlAction()?? && singleControl.getCreatePSControlAction().getPSAppDEMethod()??>${singleControl.getCreatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",WFSubmitAction:"<#if singleControl.getWFSubmitPSControlAction()?? && singleControl.getWFSubmitPSControlAction().getPSAppDEMethod()??>${singleControl.getWFSubmitPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",WFStartAction:"<#if singleControl.getWFStartPSControlAction()?? && singleControl.getWFStartPSControlAction().getPSAppDEMethod()??>${singleControl.getWFStartPSControlAction().getPSAppDEMethod().getCodeName()}</#if>"}<#if singleControl_has_next>,</#if>
    </#if>
    </#list>
    </#if>
    };
    
    /**
     * 获取工具栏按钮
     *
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public async getWFLinkModel(): Promise<any> {
        let datas: any[] = [];
        if (Object.keys(this.viewparams).length > 0) {
            Object.assign(datas, { 'taskDefinitionKey': this.viewparams.userTaskId });
        }
        const response: any = await this.appEntityService.GetWFLink({ ...this.context }, datas);
        if (response && response.status === 200) {
            this.linkModel = response.data;
            if(response.headers && response.headers['process-mobform']){
                this.computeActivedForm(response.headers['process-mobform']);
            }else{
                this.computeActivedForm(null);
            }
        } else {
            const { data: _data } = response;
            this.$notice.error(_data.message);
        }
        return response;
    }

    /**
     * 动态工具栏点击
     *
     * @param {*} linkItem
     * @param {*} $event
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public async dynamic_toolbar_click(linkItem: any, $event: any) {
        let datas: any;
        let xData: any = this.$refs.form;
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = xData.getDatas()[0];
        }
        let falg = await this.openSrfwfmemo(linkItem,datas);
        if(!falg){
            return
        }
        let res = await xData.save();
        if (!res || res.status !== 200) {
            return;
        }
        let response = await xData.wfsubmit(this.context,linkItem,datas);
        if (!response || response.status !== 200) {
            return;
        }
        const { data: _data } = response;
        if (this.viewparams) {
            this.$emit('viewdataschange', [{ ..._data }]);
            this.closeView(_data);
        } else if (this.$tabPageExp) {
            this.$tabPageExp.onClose(this.$route.fullPath);
        }
    }

    /**
     * 工作流审批意见
     *
     * @protected
     * @param {*} linkItem
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public async openSrfwfmemo(linkItem:any,data:any) :Promise<any>{
        if(linkItem && linkItem.sequenceflowmobview && this.viewRefData[`WFACTION@${r'${linkItem.sequenceflowmobview}'}`]){
            let tempContext:any = this.$util.deepCopy(this.context);
            let tempViewParam:any = {actionView:linkItem.sequenceflowmobview,actionForm:linkItem.sequenceflowmobform};
            let targetView:any = this.viewRefData[`WFACTION@${r'${linkItem.sequenceflowmobview}'}`];
            const result: any = await this.$appmodal.openModal(targetView,tempContext,tempViewParam);
            if (result || Object.is(result.ret, 'OK')) {
                const { datas } = result;
                if(datas[0].srfwfmemo){
                    this.srfwfmemo = datas[0].srfwfmemo;
                }
            }
        }
        return true;
    }

    /**
     * 视图引用数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public viewRefData:any = {
    <#if view.getPSAppViewRefs?? && view.getPSAppViewRefs()??>
    <#list view.getPSAppViewRefs() as viewRef>
    <#if viewRef.getName?? && viewRef.getName()?? && viewRef.getRefPSAppView?? && viewRef.getRefPSAppView()??>
    <#assign refAppView = viewRef.getRefPSAppView() />
        "${viewRef.getName()}":{viewname:"${srffilepath2(refAppView.getCodeName())}",title:"<#if refAppView.getPSAppDataEntity()??>entities.${refAppView.getPSAppDataEntity().getCodeName()?lower_case}.views.${refAppView.getPSDEViewCodeName()?lower_case}.caption<#else>app.views.${refAppView.getCodeName()?lower_case}.caption</#if>", width: <#if refAppView.getWidth?? && refAppView.getWidth() gt 0>${refAppView.getWidth()?c}<#else>800</#if>, height: <#if refAppView.getHeight?? && refAppView.getHeight() gt 0>${refAppView.getHeight()?c}<#else>500</#if>}<#if viewRef_has_next>,</#if>
    </#if>
    </#list>
    </#if>
    };


    /**
     * 计算激活表单
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public computeActivedForm(inputForm:any){
        if(!inputForm){
            this.activeForm = this.allForm && Object.values(this.allForm)[0];
            return;
        }
        if(this.allForm && Object.keys(this.allForm).length >0){
            Object.keys(this.allForm).forEach((name:string) =>{
                <#noparse>if(Object.is(name,`wfform_${inputForm.toLowerCase()}`)){</#noparse>
                    this.activeForm = this.allForm[name];
                }
            })
        }
    }

    /**
     * 工具栏分组是否显示的条件
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public showGrop = false;

    /**
     * 工具栏分组是否显示的方法
     *
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public popUpGroup (falg:boolean = false) {
        this.showGrop = falg;
    }

    /**
     * 底部按钮样式
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public button_style = "";

</#assign>
<#ibizinclude>
../@MACRO/VIEW-BASE.vue.ftl
</#ibizinclude>